import { message } from "antd/lib/index";
import { Button,Descriptions, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude,extendIgnoreDataRule, setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import styles from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
class FO019ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            enumData: null,
            BtnAgreeDisplay: 'none'
        };
    };

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }


    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'FO/FOTechDisclosureFrom/PersonalAgree',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('确认成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined"&&typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let json = initFilter(this.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendIgnoreDataRule(json)
        // extendRule(json, 'ID', 1, dataId);
        // extendInclude(json, 'Nav_JobName');
        // extendInclude(json, 'Nav_JobNameOut');
        // extendInclude(json, 'Nav_OperationStep');
        // extendInclude(json, 'Nav_DisclosurePerson');
        // extendInclude(json, 'Nav_DisclosurePerson.Nav_UserSignFiles.Nav_ImgFile.Nav_File');
        // extendInclude(json, 'Nav_Person');
        // extendInclude(json, 'Nav_Person.Nav_User.Nav_UserSignFiles.Nav_ImgFile.Nav_File');
        // extendInclude(json, 'Nav_Person.Nav_RelatedUser.Nav_Signs.Nav_ImgFile.Nav_File');
        // extendInclude(json, 'Nav_DisclosuredPerson');
        // extendInclude(json, 'Nav_DisclosuredPerson.Nav_User.Nav_UserSignFiles.Nav_ImgFile.Nav_File');
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'FO/FOTechDisclosureFrom/GetEdit',
            onComplete: (ret) => {
                if (ret) {
                    if(this.props.data && this.props.data.loadDataDeal)
                    {
                        this.props.data.loadDataDeal(1);
                    }
                    this.setState({ data: ret })
                    if (this.props.data.tableKey=="2" ||this.props.data.tableKey==undefined) {
                        this.setState({ BtnAgreeDisplay: 'none' })
                    }else{
                        this.setState({ BtnAgreeDisplay: 'inline' })
                    }
                //     if (ret.ID) {
                //         this.props.dispatch({
                //             type: 'app/getDataByPost',
                //             url: 'FO/FOPreShiftMeetingRecord/GetPreShiftMeetingRecord',
                //             payload: {
                //                 ID: dataId,
                //             },
                //             onComplete: (result) => {
                //                 if (result != null) {
                //                     if (result) {
                //                         this.setState({ BtnAgreeDisplay: 'inline' })
                //                     }else{
                //                         this.setState({ BtnAgreeDisplay: 'none' })
                //                     }
                //                 }
                //             }
                //         })
                //     }
                }
                else
                { message.error('请先尝试刷新，若仍然加载失败，请联系管理员排查!');}
            }
        });
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, "安全技术交底表.xlsx")
    }

    render() {
        const { data } = this.state;
        return <div>
            <div style={{ padding: '10px' }}>
                <ReactToPrint
                    trigger={() => <Button type={'default'} icon={'printer'} style={{ marginLeft: '8px',display: data && data.FORM_STATUS === 2?"inline":"none"  }}>打印</Button>}
                    content={() => this.componentRef}
                    pageStyle=".printDIV { padding:0 40px;} img{width :120px}"
                />
                <Button style={{ marginLeft: '8px',display: data && data.FORM_STATUS === 2?"inline":"none" }} onClick={() => this.onTableBtnExport()} icon="export" >导出</Button>
                <Button type="primary" style={{ marginLeft: '8px', display: this.state.BtnAgreeDisplay }} onClick={() => this.onTableBtnAgree()} icon="check" >确认</Button>
            </div>


            {/*  */}
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id} className="printDIV">

                <h1 style={{ textAlign: 'center', margin: '15px' }}>安全技术交底表</h1>
                {
                     data ?
                     <table style={{ width: '100%', textAlign: 'center', borderTop: '1px solid #333', borderLeft: '1px solid #333' }} className={styles.PrintForm}>
                        <tbody>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>编号</td>
                                <td colSpan={3} rowSpan={1}>{data.CODE}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>作业名称</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_OperationStep?data.Nav_OperationStep?.NAME:''}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>作业地点</td>
                                <td colSpan={3} rowSpan={1}>{data.JOB_LOCATION}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>交底时间</td>
                                <td colSpan={3} rowSpan={1}>{data.DISCLOSURE_DATE?data.DISCLOSURE_DATE:null}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>交底人</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_DisclosurePerson?data.Nav_DisclosurePerson?.NAME:''}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>被交底人</td>
                                <td colSpan={3} rowSpan={1}>{
                                data.IS_OUTSOURCE == false && data.Nav_Person && data.Nav_Person.map((item, i) => {
                                    if (i == (data.Nav_Person.length - 1)) {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'> {item.Nav_User?.NAME}</label>
                                        else
                                            return item.Nav_User?.NAME
                                    } else {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'>{item.Nav_User?.NAME + '  '}</label>
                                        else
                                            return item.Nav_User?.NAME + '  '
                                    }
                                })
                            }
                            {
                                data.IS_OUTSOURCE == true && data.Nav_Person && data.Nav_Person.map((item, i) => {
                                    if (i == (data.Nav_Person.length - 1)) {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'> {item.Nav_RelatedUser?.NAME}</label>
                                        else
                                            return item.Nav_RelatedUser?.NAME
                                    } else {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'>{item.Nav_RelatedUser?.NAME + '  '}</label>
                                        else
                                            return item.Nav_RelatedUser?.NAME + '  '
                                    }
                                })
                            }
                            </td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>交底内容</td>
                                <td colSpan={8} rowSpan={1}>{data.DisclosureContent}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>交底人签字</td>
                                <td colSpan={8} rowSpan={1}>{
                                    (data.Nav_DisclosurePerson && data.Nav_DisclosurePerson.Nav_UserSignFiles[0])?
                                    <img style={{ margin: "0 0 0 15px",width:'150px' }} alt={data.Nav_DisclosurePerson?.NAME} src={config.picServerHost + data.Nav_DisclosurePerson.Nav_UserSignFiles[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                    :data.Nav_DisclosurePerson?.NAME
                                    // data.Nav_DisclosurePerson && data.Nav_DisclosurePerson.map((item, i) => {
                                    //     if (item.FORM_STATUS >= 1) {
                                    //         if (item.Nav_User != null && item.Nav_User.Nav_UserSignFiles[0] != null)
                                    //             return <img width={'20%'} alt={item.Nav_User.NAME} src={config.picServerHost + item.Nav_User.Nav_UserSignFiles[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                    //         else
                                    //             return <img width={'20%'} title={item.Nav_User.NAME} />
                                    //     }
                                    // })
                                }</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>被交底人签字</td>
                                <td colSpan={8} rowSpan={1}>{
                                    data.IS_OUTSOURCE == false && data.Nav_Person && data.Nav_Person.map((item, i) => {
                                        if (item.DEAL_STATUS == 1) {
                                            if (item.Nav_User != null && item.Nav_User.Nav_UserSignFiles[0] != null)
                                                return <img style={{ margin: "0 0 0 15px",width:'150px' }} alt={item.Nav_User?.NAME} src={config.picServerHost + item.Nav_User.Nav_UserSignFiles[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                            else
                                                return <img style={{ margin: "0 0 0 15px",width:'150px' }} title={item.Nav_User?.NAME} />
                                        }
                                    })
                                }
                                {
                                    data.IS_OUTSOURCE == true && data.Nav_Person && data.Nav_Person.map((item, i) => {
                                        if (item.DEAL_STATUS == 1) {
                                            if (item.Nav_RelatedUser != null && item.Nav_RelatedUser.Nav_Signs[0] != null)
                                                return <img style={{ margin: "0 0 0 15px",width:'150px' }} alt={item.Nav_RelatedUser?.NAME} src={config.picServerHost + item.Nav_RelatedUser.Nav_Signs[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                            else
                                                return <img style={{ margin: "0 0 0 15px",width:'150px' }} title={item.Nav_RelatedUser?.NAME} />
                                        }
                                    })
                                }
                                </td>
                            </tr>
                        </tbody>
                     </table>:null
                }
            </div>
        </div>
    }

}
export default connect(({ login }) => ({ login }))(FO019ShowPrint) 